


#include "Curvature.h"
#include "Tensor2.h"
Curvature::Curvature(vertex * pvertex)
{
    m_pVertex=pvertex;

    std::vector<triangle *> Ntr=m_pVertex->GetVTraingleList();
    
    double Area=0.0;
    Vec3D Normal;
    for (std::vector<triangle *>::iterator it = Ntr.begin() ; it != Ntr.end(); ++it)
    {
        Vec3D v=(*it)->GetNormalVector();
        double a=(*it)->GetArea();
        v=v*a;
        
             
       
        Normal=Normal+v;
        

        
        Area+=a;
        
    }

    Area=Area/3.0;
   

  
    if(Area==0)
    {
    std::cout<<Ntr.size()<<"\n";
	std::string sms=" WARNING: vertex has a zero area \n";
	std::cout<<sms<<"\n";
    }
    else if(Area<0)
    {
	std::string sms=" WARNING: vertex has a negetive area \n";
	std::cout<<sms<<"\n";
    }


    double no=Normal.norm();
    no=1.0/no;
    Normal=Normal*no;
    m_pVertex->UpdateNormal_Area(Normal,Area);
    

   // std::cout<<Normal(0)<<"  "<<Normal(1)<<"  "<<Normal(2)<<"\n";
    ///=======
    //=== Shape Operator
    //========
    Tensor2  SV;
    Tensor2 IT('I');
    
    Tensor2 P=IT-IT.makeTen(Normal);

 

    Tensor2 Pt=P.Transpose(P);
    std::vector<links *> NLinks=m_pVertex->GetVLinkList();




    for (std::vector<links *>::iterator it = NLinks.begin() ; it != NLinks.end(); ++it)
    {
       if((*it)->GetMirrorFlag()==true)
	   {
        Vec3D ve=(*it)->GetNormal();
        double we=ve.dot(Normal,ve);
        

        Vec3D Be=(*it)->GetBe();
        double he=(*it)->GetHe();
        Vec3D Se;
        for (int n=0;n<3;n++)
        {
            Se(0)=Se(0)+P(0,n)*Be(n);
            Se(1)=Se(1)+P(1,n)*Be(n);
            Se(2)=Se(2)+P(2,n)*Be(n);
        }
        
        double ff=Se.norm();
        
        
        if(ff==0)
        {
            std::cout<<"projection is zero error"<<"\n";
        }
        else
        {
            Se=Se*(1.0/ff);
        }
        
        Tensor2 Q=P.makeTen(Se);
        
        SV=SV+(Q)*(we*he);
        
        
	}
        
    }


    ///=============
    //==== Find Curvature and local frame
    //=============
    
    Tensor2 Hous;
    Vec3D Zk;
    Zk(2)=1.0;
    double SignT=1;
  
    if((1+Normal(2))>(1-Normal(2)))   // 1+/-Normal(2) is always larger then 1
    {
        Zk=Zk+Normal;
        SignT=-1;
      
    }
    else if((1+Normal(2))<=(1-Normal(2)))
    {
       Zk=Zk-Normal;
    }
    
    double noz=Zk.norm();
    
    Zk=Zk*(1.0/noz);
   
    Tensor2 I('I');
    Tensor2 W=Hous.makeTen(Zk);
    
    Hous=(I-(W*(W.Transpose(W)))*2)*SignT;


    
    Tensor2 LSV;// Local SV
    LSV=(Hous.Transpose(Hous))*(SV*Hous);    // LSV is the curvature matrix in the local frame, the it is a 2*2 minor matrix since all the 3 component are zero.


  /*  std::cout<<LSV(0,0)<<" "<<LSV(0,1)<<" "<<LSV(0,2)<<" "<<"\n";
    std::cout<<LSV(1,0)<<" "<<LSV(1,1)<<" "<<LSV(1,2)<<" "<<"\n";
    std::cout<<LSV(2,0)<<" "<<LSV(2,1)<<" "<<LSV(2,2)<<" "<<"\n";
    std::cout<<"\n";*/


    double b=LSV(0,0)+LSV(1,1);
    double c=LSV(0,0)*LSV(1,1)-LSV(1,0)*LSV(0,1);
    




    double delta=b*b-4*c;
    double c1,c2;
    if(delta>0.0)
    {
    delta=sqrt(delta);
    c1=b+delta;
    c1=0.5*c1;      // c1 always will be larger then c2
    c2=b-delta;
    c2=0.5*c2;
        

    }
    else if (fabs(delta)<0.0001)
    {
        
    c1=0.5*b;
    c2=c1;

    }
    else
    {
        c1=0;
        c2=0;
        std::cout<<delta<<"  error: delta is negative, this means curvature cannot be found \n";
    }

   // if(true) in general we do not need this, only if we have directional inclsuions
    {
    Tensor2 EigenvMat('O');
    
    double p=LSV(0,0);
    double q=LSV(0,1);


    double size=sqrt(q*q+(c1-p)*(c1-p));                   // The Eigenvectors can be calculated using this equation LSV*R=c1*R
    EigenvMat(0,0)=q/size;                                  // only one of them needs to be calculated, one is normal vector and the other is perpendicular to first one
    EigenvMat(1,0)=(c1-p)/size;
    EigenvMat(0,1)=-EigenvMat(1,0);
    EigenvMat(1,1)=EigenvMat(0,0);
    EigenvMat(2,2)=1;

    
    

        
        

        
        
        


//  Tensor2 TransferMatGL=EigenvMat*Hous;   /// This matrix transfers vectors from Global coordinate to local coordinate//
//  Tensor2 TransferMatLG = TransferMatGL.Transpose(TransferMatGL);//// This matrix transfers vectors from local coordinate to global coordinate
        
        
        

        
        ///  this is correct, We can check by applying transpose(E)*t1 = (1,0,0)
        
     Tensor2 TransferMatLG=Hous*EigenvMat;   /// This matrix transfers vectors from local coordinate to global coordinate
     Tensor2 TransferMatGL=TransferMatLG.Transpose(TransferMatLG);   /// This matrix transfers vectors from Global coordinate to local coordinate


        
    m_pVertex->UpdateL2GTransferMatrix(TransferMatLG);
    m_pVertex->UpdateG2LTransferMatrix(TransferMatGL);


        
        if(pvertex->VertexOwnInclusion()==true)
        {
        inclusion * in=pvertex->GetInclusion();
        Vec3D LD=in->GetLDirection();
        Vec3D GD=TransferMatLG*LD;
       // in->UpdateGlobalDirection(GD);
        }
        




 



#if TEST_MODE == Enabled
        ///// here should be corrected  . we need a good test to see if the transformation is correct
        Vec3D localN(0,0,1);
        Vec3D GN1 = TransferMatLG*localN;
    if( fabs(Normal(2)-GN1(2))>0.001 || fabs(Normal(1)-GN1(1))>0.001 || fabs(Normal(0)-GN1(0))>0.001)
    {
        std::cout<<" error code 1110319: something is unusuall \n";
        std::cout<<" transfer matrix does not work well \n";
        std::cout<<Normal(0)<<"   "<<Normal(1)<<"   "<<Normal(2)<<"   G \n";
        std::cout<<GN1(0)<<"   "<<GN1(1)<<"   "<<GN1(2)<<"  Local to G  \n";

        std::cout<<"\n ";
    }
        Vec3D LN = TransferMatGL*Normal;
        if( fabs(LN(0))>0.0001 || fabs(LN(1))>0.0001 || fabs(1-LN(2))>0.001)
        {
            std::cout<<" error code 1110319: something is unusuall \n";
            std::cout<<" transfer matrix does not work well \n";
            std::cout<<LN(0)<<"   "<<LN(1)<<"   "<<LN(2)<<"  Local to G  \n";
            
            std::cout<<"\n ";
        }

        
         Vec3D k1(1,2,3);
         Vec3D k2=TransferMatLG*k1;
         Vec3D k3=TransferMatGL*k2;
        
        if(fabs(k1(0)-k3(0))>0.0001 ||fabs(k1(1)-k3(1))>0.0001  || fabs(k1(2)-k3(2))>0.0001 )
        {
            std::cout<<" transfer matrix does not work well: when we transfer and back v=1,2,3 \n";
         std::cout<<"===============\n";
         std::cout<<k1(0)<<" "<<k1(1)<<" "<<k1(2)<<" \n";
         std::cout<<k3(0)<<" "<<k3(1)<<" "<<k3(2)<<" \n";
        }
#endif
        
        
    }
    
    c1=c1/Area;
    c2=c2/Area;
    

    

    m_pVertex->UpdateCurvature(c1,c2);
 
    
    
    

    
    

}


Curvature::~Curvature()
{
    
}

//void Curvature::UpdateRepresentation(bool z)
//{
//m_Representation=z;
//}
/// normal vector update






